/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

//import ijp.ijpassignment1.chat.ChatBot;
//import ijp.ijpassignment1.langen.TemplateLanguageGenerator;

/**
 * This class is part of the "Travelling in Sibiria application".
 * It represents a character that the player can meet in a room.
 * A Person has a name, a description, a small speech processing
 * and a set of the items it sells.
 * 
 * has subclasses Seller, Driver, Chatter
 * @author vera
 * @version 1.0 (December 2004)
 */
public class Person extends ChatBot {//I reused a version of my ChatBot class for the speech processing
	TemplateLanguageGenerator tlg;//a language generation class
	
	
	/**
	 * give the person a name and a description and get a language processor
	 * @param name of Character
	 * @param description of Character
	 */
	public Person(String name, String description) {
		super(name, description);//sets a name and a description using the Chatbot constructor
		tlg = getTLG();//gets the templateLanguageGenerator instance from the ChatBot class
		
	}
	
	/**
	 * give to the Character sentences which it can produce.
	 * 
	 * @param type (for example "init"/"question")
	 * @param sentence (The sentence template to attributed to the person) 
	 * 			Can be of from ""bla bla bla" and contain holes ||VERB|| ||ADJECTIVE|| ||NOUN||
	 */
	public void setSentence(String type, String sentence){//type is not really made use of, this is a problem from my ChatBot project

		tlg.populateSentences(type,sentence);
	}
	
	/**
	 * give to a character keywords to which it can react and the reactions to it.
	 * The answer must not contain holes (||VERB||).
	 * @param keyword (for example "expensive")
	 * @param answer (for example "no reduction available."
	 */
	public void setKeyWordAndAnswer(String keyword, String answer){
		tlg.keyWordListConstructor(keyword, answer); 
	}
	
	/**
	 * get the keywords that were used in the last sentences
	 * gives a small memory of what has been said to the person.
	 * @return an Arraylist of those keywords 
	 */
	public ArrayList getSalients(){
		return tlg.getSalientWords();
	}


	/**
	 * for each item that is in a room with the person, attribute a sentence to the person
	 * in which the person reacts to the name of the item tells its price.
	 * @param items a HashMap of Items from the Room
	 */
	public void setSoldItems(HashMap items) {
		Set keys = items.keySet();//get the descriptions of the items
		Iterator iter = keys.iterator();
		String i;
		while (iter.hasNext()){
			i = (String) iter.next();//for each description of an item create a sentence also containning its prize.
			setKeyWordAndAnswer(i,"The " +i+ " is "+ ((Item) items.get(i)).getTouristPrize()+ " Roubles.");
		}
	}
}
